;### LIBRARY ###
	
PtSsym:	;   
	;      !
	;HL - YX (y:0-191,x:0-31)
	;DE - SPRITE 
	;BC - HW
	PUSH DE
	EX DE,HL
	CALL BCOORD
	POP DE
	EX DE,HL
	LD A,C
	LD (.loop1+1),A
	LD C,B
.loop1:	LD B,0
	PUSH DE
.loop2:	LD A,(HL)
	LD (DE),A
	INC HL
	INC E
	DJNZ .loop2
	POP DE
	CALL DOWNDE
	DEC C
	JR NZ,.loop1
	RET
	
PtSatr:	; 
	;      !
	;HL - YX (y:0-23,x:0-31)
	;DE - SPRITE 
	;BC - HW
	PUSH DE
	EX DE,HL
	CALL ACOORD
	POP DE
	EX DE,HL
	LD A,C
	LD (.loop1+1),A
	LD C,B
.loop1:	LD B,0
	PUSH DE
.loop2:	LD A,(HL)
	LD (DE),A
	INC HL
	INC E
	DJNZ .loop2
	POP DE
	LD A,E
	ADD A,32
	LD E,A
	JR NC,.lbl1
	INC D
.lbl1:	DEC C
	JR NZ,.loop1	
	RET
	
PCpg7:	LD A,$D8
	LD (ACOORD.ADDR+1),A
	LD A,$C0
	LD (PCOORD.ADDR+1),A
	LD (BCOORD.ADDR+1),A
	LD (SCOORD.ADDR+1),A
	RET
	
PCpg5:	LD A,$58
	LD (ACOORD.ADDR+1),A
	LD A,$40
	LD (PCOORD.ADDR+1),A
	LD (BCOORD.ADDR+1),A
	LD (SCOORD.ADDR+1),A
	RET	

WT:	/*2 table*/ RLCA:ADD A,L:LD L,A:JR NC,$+3:INC H:LD A,(HL):INC HL:LD H,(HL):LD L,A:RET 
BT:	/*1 table*/ ADD A,L:LD L,A:JR NC,$+3:INC H:LD A,(HL):RET 
	
Pager:	;  
	PUSH AF
.skip:	PUSH BC:LD (.cur),A:LD B,A:LD A,(SCRout):OR B:OR 16:LD BC,$7FFD:OUT (C),A:POP BC:POP AF:RET 
.cur:	DB 0
PAGESCR:PUSH AF:LD A,(SCRwork):OR A:JR Z,PAGE5+1:JR PAGE7+1
PAGESCO:PUSH AF:LD A,(SCRwork):OR A:JR NZ,PAGE5+1:JR PAGE7+1
PAGE0:	PUSH AF:XOR A:JR Pager.skip
PAGE1:	PUSH AF:LD A,1:JR Pager.skip
PAGE2:	PUSH AF:LD A,2:JR Pager.skip
PAGE3:	PUSH AF:LD A,3:JR Pager.skip
PAGE4:	PUSH AF:LD A,4:JR Pager.skip
PAGE5:	PUSH AF:LD A,5:JR Pager.skip
PAGE6:	PUSH AF:LD A,6:JR Pager.skip
PAGE7:	PUSH AF:LD A,7:JR Pager.skip
PAGESP:	PUSH AF:CALL PCpg5:LD A,(SCRwork):OR A:JR Z,PAGE7+1:CALL PCpg7:JR PAGE7+1
	
DOWNBC:	INC B:LD A,B:AND 7:RET NZ:LD A,C:ADD A,32:LD C,A:RET C:LD A,B:SUB 8:LD B,A:RET
DOWNDE:	INC D:LD A,D:AND 7:RET NZ:LD A,E:ADD A,32:LD E,A:RET C:LD A,D:SUB 8:LD D,A:RET
DOWNHL:	INC H:LD A,H:AND 7:RET NZ:LD A,L:ADD A,32:LD L,A:RET C:LD A,H:SUB 8:LD H,A:RET 
	
PCOORD:	LD A,D ;de(0-191,0-255) -- hl
	RRCA:RRCA:RRCA:LD L,A:AND $18
.ADDR:	ADD A,$C0:LD H,A:LD A,D:AND 7:ADD A,H:LD H,A:LD A,L:LD L,E:RRA:RR L:RRA:RR L:RRA:RR L:RET 
	
BCOORD: LD A,D ;de(0-191,0-31) -- hl
	RRCA:RRCA:RRCA:AND $18
.ADDR:	ADD A,$C0:LD H,A:LD A,D:AND 7:ADD A,H:LD H,A:LD A,D:RLA:RLA:AND $E0:OR E:LD L,A:RET 
	
SCOORD: LD A,D ;de(0-23,0-31)--hl
	AND $18
.ADDR:	ADD A,$C0:LD H,A:LD A,D:RRCA:RRCA:RRCA:AND $E0:OR E:LD L,A:RET 
	
ACOORD: LD A,D ;de(0-23,0-31)--hl
	AND $18:RRCA:RRCA:RRCA
.ADDR:	ADD A,$D8:LD H,A:LD A,D:RRCA:RRCA:RRCA:AND $E0:OR E:LD L,A:RET 
	
genRND:	; 
        LD HL,genRND
	LD A,H
	ADD A,$77
	LD H,A
	RLC L
	ADD A,L
	LD L,A
	LD (genRND+1),HL
	RET
	
gnRNDi: ;  
.loop1:	CALL genRND
	CP D
	JR C,.loop1
	CP E
	JR NC,.loop1
	; A  
	RET
	
RNDGEN  PUSH DE
        LD A,R
        RRCA 
        LD E,A
RND1E   LD A,134
        SBC A,E
        RRCA 
        RRCA 
        LD (RND1E+1),A
        RL A
        LD D,A
RND2E   LD A,233
        ADC A,D
        RLCA 
        RLCA 
        LD D,A
        LD (RND2E+1),A
RND3E   LD A,221
        ADC A,D
        RLCA 
        XOR E
        RLCA 
        LD (RND3E+1),A
        POP DE
        RET 