;### LIBRARY ###

DcrMAP:	;  (1 >> 2)
	CALL PAGE4
	LD HL,$C000
	LD A,(mapNUM)
	CALL WT
	EX DE,HL
	LD IXH,D
	LD IXL,E
	LD C,(IX)
	LD B,(IX+1)
	INC IX
	INC IX
	LD DE,mapSPR
	LD IY,$C000
.loop1:
	CALL PAGE4
	LD H,0
	LD L,(IX)
	INC IX
	ADD HL,HL ;2x
	ADD HL,HL ;4x
	ADD HL,HL ;8x
	ADD HL,HL ;16x
	ADD HL,HL ;32x
	ADD HL,DE
	CALL PAGE6
	LD (IY),L
	LD (IY+1),H
	INC IY
	INC IY	
	DEC BC
	LD A,C
	OR B
	JR NZ,.loop1
	RET

PrPanelR:
	;   
	CALL PAGE7
	CALL .lbl1
	CALL PAGE5
.lbl1:	LD HL,22 ;X - 22
	LD DE,rPanel
	LD BC,$C00A
	CALL PtSsym
	EX DE,HL
	LD HL,22
	LD BC,$180A
	CALL PtSatr
	RET
	
PtSsym:	;   
	;      !
	;HL - YX (y:0-191,x:0-31)
	;DE - SPRITE 
	;BC - HW
	PUSH DE
	EX DE,HL
	CALL BCOORD
	POP DE
	EX DE,HL
	LD A,C
	LD (.loop1+1),A
	LD C,B
.loop1:	LD B,0
	PUSH DE
.loop2:	LD A,(HL)
	LD (DE),A
	INC HL
	INC E
	DJNZ .loop2
	POP DE
	CALL DOWNDE
	DEC C
	JR NZ,.loop1	
	RET
	
PtSatr:	; 
	;      !
	;HL - YX (y:0-191,x:0-31)
	;DE - SPRITE 
	;BC - HW
	PUSH DE
	EX DE,HL
	CALL ACOORD
	POP DE
	EX DE,HL
	LD A,C
	LD (.loop1+1),A
	LD C,B
.loop1:	LD B,0
	PUSH DE
.loop2:	LD A,(HL)
	LD (DE),A
	INC HL
	INC E
	DJNZ .loop2
	POP DE
	LD A,E
	ADD A,32
	LD E,A
	JR NC,.lbl1
	INC D
.lbl1:	DEC C
	JR NZ,.loop1	
	RET

WT:	;2 table
	RLCA
	ADD A,L
	LD L,A
	JR NC,$+3
	INC H
	LD A,(HL)
	INC HL
	LD H,(HL)
	LD L,A
	RET 

BT:	;1 table
	ADD A,L
	LD L,A
	JR NC,$+3
	INC H
	LD A,(HL)
	RET 
	
ClrSCR:	; 
	CALL PAGE5
	CALL .lbl1
	CALL PAGE7
.lbl1:	LD HL,$C000
	LD DE,$C001
	LD BC,6144
	LD (HL),L
	LDIR
	LD BC,767
	LD (HL),7+64
	LDIR
	RET

SetISR:	; 
	;BY AlCo
	LD HL,$6000
	LD A,H
	LD I,A
	LD DE,$6001
	LD BC,$100
	LD (HL),$5C
	LDIR 
	LD L,(HL)
	LD H,L
	LD (HL),$C3
	INC HL
	LD (HL),(ISR - (ISR/256*256))
	INC HL
	LD (HL),ISR/256
	IM 2
	RET 	
	
Pager:	;  
	PUSH AF
Pager0:	PUSH BC
	LD B,A
	LD A,(SCRout)
	OR B
	OR 16
	LD BC,$7FFD
	OUT (C),A
	POP BC,AF
	RET 
PAGESCR:
	PUSH AF
	LD A,(SCRwork)
	OR A
	JR Z,PAGE5+1
	JR PAGE7+1
PAGE0:	PUSH AF
	XOR A
	JR Pager0
PAGE1:	PUSH AF
	LD A,1
	JR Pager0
PAGE2:	PUSH AF
	LD A,2
	JR Pager0
PAGE3:	PUSH AF
	LD A,3
	JR Pager0
PAGE4:	PUSH AF
	LD A,4
	JR Pager0
PAGE5:	PUSH AF
	LD A,5
	JR Pager0
PAGE6:	PUSH AF
	LD A,6
	JR Pager0
PAGE7:	PUSH AF
	LD A,7
	JR Pager0
	
DOWNBC:	INC B
	LD A,B
	AND 7
	RET NZ
	LD A,C
	ADD A,$20
	LD C,A
	RET C
	LD A,B
	SUB 8
	LD B,A
	RET

DOWNDE:	INC D
	LD A,D
	AND 7
	RET NZ
	LD A,E
	ADD A,$20
	LD E,A
	RET C
	LD A,D
	SUB 8
	LD D,A
	RET
	 
DOWNHL:	INC H
	LD A,H
	AND 7
	RET NZ
	LD A,L
	ADD A,$20
	LD L,A
	RET C
	LD A,H
	SUB 8
	LD H,A
	RET 
	
PCOORD:	LD A,D ;de(0-191,0-255) -- hl
	RRCA 
	RRCA 
	RRCA 
	LD L,A
	AND $18
.ADDR:	ADD A,$C0
	LD H,A
	LD A,D
	AND 7
	ADD A,H
	LD H,A
	LD A,L
	LD L,E
	RRA 
	RR L
	RRA 
	RR L
	RRA 
	RR L
	RET 
	
BCOORD: LD A,D ;de(0-191,0-31) -- hl
	RRCA 
	RRCA 
	RRCA 
	AND $18
.ADDR:	ADD A,$C0
	LD H,A
	LD A,D
	AND $07
	ADD A,H
	LD H,A
	LD A,D
	RLA 
	RLA 
	AND $E0
	OR E
	LD L,A
	RET 
	
SCOORD: LD A,D ;de(0-23,0-31)--hl
	AND $18
.ADDR:	ADD A,$C0
	LD H,A
	LD A,D
	RRCA 
	RRCA 
	RRCA 
	AND $E0
	OR E
	LD L,A
	RET 
	
ACOORD: LD A,D ;de(0-23,0-31)--hl
	AND $18
.ADDR:	ADD A,$D8
	LD H,A
	LD A,D
	RRCA 
	RRCA 
	RRCA 
	AND $E0
	OR E
	LD L,A
	RET 